# Generated by Django 4.0 on 2021-12-13 14:29

from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    dependencies = [
        ('banner', '0010_auto_20200428_1232'),
    ]

    operations = [
        migrations.AlterField(
            model_name='banner',
            name='position',
            field=models.CharField(choices=[('SDR', 'Sidebar Höger, 160x600'), ('SDL', 'Sidebar Vänster, 160x600'), ('CON', 'Content, 1140x90'), ('BOT', 'Botten, 1140x90')], default='CON', max_length=3),
        ),
        migrations.CreateModel(
            name='BannerViews',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(default=django.utils.timezone.now, verbose_name='datum')),
                ('count', models.IntegerField(default=0, verbose_name='Visningar')),
                ('banner_id', models.ForeignKey(default=0, on_delete=django.db.models.deletion.CASCADE, to='banner.banner')),
            ],
            options={
                'verbose_name': 'Banner Visning',
                'verbose_name_plural': 'Banner Visningar',
                'ordering': ['-date'],
            },
        ),
        migrations.CreateModel(
            name='BannerTotalClicks',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('count', models.IntegerField(default=0, verbose_name='Klicks')),
                ('date', models.DateField(default=django.utils.timezone.now, verbose_name='datum')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('banner_id', models.ForeignKey(default=0, on_delete=django.db.models.deletion.CASCADE, to='banner.banner')),
            ],
            options={
                'verbose_name': 'Banner Total Click',
                'verbose_name_plural': 'Banner Total Clicks',
                'ordering': ['-date'],
            },
        ),
        migrations.CreateModel(
            name='BannerStatistics',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(default=django.utils.timezone.now, verbose_name='datum')),
                ('impressions', models.IntegerField(default=0, verbose_name='Impressions')),
                ('views', models.IntegerField(default=0, verbose_name='Views')),
                ('clicks', models.IntegerField(default=0, verbose_name='Clicks')),
                ('banner', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='banner.banner')),
            ],
            options={
                'verbose_name': 'Banner Statistic',
                'verbose_name_plural': 'Banner Statistics',
                'ordering': ['-date'],
            },
        ),
        migrations.CreateModel(
            name='BannerImpressions',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(default=django.utils.timezone.now, verbose_name='datum')),
                ('count', models.IntegerField(default=0, verbose_name='Impressions')),
                ('banner_id', models.ForeignKey(default=0, on_delete=django.db.models.deletion.CASCADE, to='banner.banner')),
            ],
            options={
                'verbose_name': 'Banner Impressions',
                'verbose_name_plural': 'Banner Impressions',
                'ordering': ['-date'],
            },
        ),
        migrations.CreateModel(
            name='BannerClicks',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('url', models.URLField(default='', verbose_name='URL')),
                ('full_url', models.URLField(default='', verbose_name='URL')),
                ('date', models.DateField(default=django.utils.timezone.now, verbose_name='datum')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('banner', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='banner.banner')),
            ],
            options={
                'verbose_name': 'Banner Click',
                'verbose_name_plural': 'Banner Clicks',
                'ordering': ['-date'],
            },
        ),
    ]
